/*
**    DRICHECK.SQL
**
**    Add some CHECK constraints.
*/


PRINT 'Begin DRICHECK.SQL'
GO

USE Credit
SET NOCOUNT ON
GO
IF ( (SELECT db_name()) <> 'Credit')
BEGIN
   RAISERROR ('Database "Credit" not found.',22,127) WITH LOG
END
GO



/*
**    All payments must have a non-zero value.  
*/

IF EXISTS (SELECT name FROM sysobjects WHERE name = 'payment_amount_rule')
  ALTER TABLE payment
    DROP CONSTRAINT payment_amount_rule
ALTER TABLE payment
  WITH NOCHECK
  ADD CONSTRAINT payment_amount_rule CHECK (payment_amt <> 0)
GO


  
/*
**    The due date must not be prior to the statement date.
*/

IF EXISTS (SELECT name FROM sysobjects WHERE name = 'statement_dt_rule')
  ALTER TABLE statement
    DROP CONSTRAINT statement_dt_rule
ALTER TABLE statement
  WITH NOCHECK
  ADD CONSTRAINT statement_dt_rule CHECK (due_dt >= statement_dt)
GO
