/*
**  CREADRFK.SQL
**  
**  Create ALL the Foreign Keys. 
**
**  Don't forget to say 'USE credit' first.
*/

PRINT 'Begin CREADRFK.SQL'
GO
SET NOCOUNT ON
GO
IF ( (SELECT db_name()) <> 'Credit')
BEGIN
   RAISERROR ('Database "Credit" not found.',22,127) WITH LOG
END
GO

USE Credit
go

/*
**    Drop the old constraints.
*/

IF EXISTS (SELECT name FROM sysobjects WHERE name = 'charge_provider_link')
  ALTER TABLE charge
    DROP CONSTRAINT charge_provider_link
GO
IF EXISTS (SELECT name FROM sysobjects WHERE name = 'charge_member_link')
  ALTER TABLE charge
    DROP CONSTRAINT charge_member_link
GO


IF EXISTS (SELECT name FROM sysobjects WHERE name = 'provider_ident')
  ALTER TABLE provider
    DROP CONSTRAINT provider_ident
IF EXISTS (SELECT name FROM sysindexes WHERE name = 'provider_ident')
    DROP INDEX  provider.provider_ident

IF EXISTS (SELECT name FROM sysobjects WHERE name = 'member_ident')
  ALTER TABLE member
    DROP CONSTRAINT member_ident
IF EXISTS (SELECT name FROM sysindexes WHERE name = 'member_ident')
    DROP INDEX  member.member_ident

IF EXISTS (SELECT name FROM sysobjects WHERE name = 'charge_ident')
  ALTER TABLE charge
    DROP CONSTRAINT charge_ident
IF EXISTS (SELECT name FROM sysindexes WHERE name = 'charge_ident')
    DROP INDEX  charge.charge_ident
GO


/*
**    Termination
*/


USE master

EXEC sp_dboption Credit, 'dbo use only', FALSE
GO
