CREATE DATABASE [TestFGDB]
	ON PRIMARY 
	(NAME = N'TestFGDBData', 
	FILENAME = N'C:\Program Files\Microsoft SQL Server\mssql\data\TestFGDB2Data.MDF' , 
	SIZE = 10,
	FILEGROWTH = 10%,
	MAXSIZE = 15)
LOG ON 
	(NAME = N'TestFGDBLog', 
	FILENAME = N'C:\Program Files\Microsoft SQL Server\mssql\data\TestFGDBLog.LDF' , 
	SIZE = 10, FILEGROWTH = 10%)
--COLLATE collation name
--SELECT * FROM ::fn_helpcollations()
go
ALTER DATABASE [TestFGDB] ADD FILEGROUP [fg] 
go
ALTER DATABASE [TestFGDB] 
	ADD FILE
		(NAME = N'TestFGDBFile1', 
		FILENAME = N'C:\Program Files\Microsoft SQL Server\mssql\data\TestFGDBFile1.NDF' , 
		SIZE = 10, FILEGROWTH = 10%) 
		TO FILEGROUP [fg]
go
ALTER DATABASE [TestFGDB] 
	ADD FILE
		(NAME = N'TestFGDBFile2', 
		FILENAME = N'C:\Program Files\Microsoft SQL Server\mssql\data\TestFGDBFile2.NDF' , 
		SIZE = 10, FILEGROWTH = 10%) 
		TO FILEGROUP [fg]
go
ALTER DATABASE [TestFGDB] 
	ADD FILE
		(NAME = N'TestFGDBFile3', 
		FILENAME = N'C:\Program Files\Microsoft SQL Server\mssql\data\TestFGDBFile3.NDF' , 
		SIZE = 10, FILEGROWTH = 10%) 
		TO FILEGROUP [fg]
go
USE TestFGDB
go
sp_helpfile
go

CREATE TABLE dbo.DemoTable2
(
	col1	int	 identity(100,10),
	col2	datetime default current_timestamp,
	col3	datetime default getdate(),
	col4	char(30) default suser_name(),
	col5	char(30) default user_name(),
	col6	char(80) default 'Now is the time for all good men to come to the aid of their country.'
) 
go
select count(*) from dbo.DemoTable
go

while 1=1
insert dbo.DemoTable default values
go
ALTER DATABASE TestFGDB
	MODIFY FILEGROUP [fg] DEFAULT
go
ALTER DATABASE TestFGDB
	MODIFY FILEGROUP [fg] READONLY
-- DO NOT NOT NOT NOT EVER NEVER EVER.... USE THIS OPTION!!!!!!!
-- Read InstantDoc ID #26067
go
ALTER DATABASE TestFGDB
	MODIFY FILEGROUP [fg] READWRITE
go
ALTER DATABASE [TestFGDB] ADD FILEGROUP [fgtest] 
go
ALTER DATABASE [TestFGDB] 
	ADD FILE
		(NAME = N'TestFGDBTestFile1', 
		FILENAME = N'C:\Program Files\Microsoft SQL Server\mssql\data\TestFGDBTestFile1.NDF' , 
		SIZE = 10, FILEGROWTH = 10%) 
		TO FILEGROUP [fgtest]
go
ALTER DATABASE [TestFGDB] 
	ADD FILE
		(NAME = N'TestFGDBTestFile2', 
		FILENAME = N'C:\Program Files\Microsoft SQL Server\mssql\data\TestFGDBTestFile2.NDF' , 
		SIZE = 10, FILEGROWTH = 10%) 
		TO FILEGROUP [fgtest]
go
sp_help Demotable -- notice that it shows on fg 
go
--DROP INDEX demotable.foo
CREATE UNIQUE CLUSTERED INDEX foo 
	ON Demotable(Col1)
	ON fgtest
go
CREATE UNIQUE INDEX bar
	ON Demotable(Col1)
	ON fg
go

sp_help Demotable -- notice that it now shows on fgtest
go
-- Let's make a filegroup for the DEFAULT objects.
-- Default objects are objects created where the filegroup 
-- name is NOT specified. By default, the default filegroup
-- is the same as the PRIMARY filegroup and you might want
-- ONLY the system tables (the database catalog) to be on the 
-- PRIMARY filegroup...
ALTER DATABASE TestFGDB
	MODIFY FILEGROUP [fg] DEFAULT
go
CREATE TABLE dbo.DemoTable2
(
	col1	int	 identity(100,10),
	col2	datetime default current_timestamp,
	col3	datetime default getdate(),
	col4	char(30) default suser_name(),
	col5	char(30) default user_name(),
	col6	char(80) default 'Now is the time for all good men to come to the aid of their country.'
) -- NOTICE that I'm not specifying the filegroup that this obj
-- should be created on...
go
sp_help demotable2 -- this will show as filegroup fg because
			-- fg is the DEFAULT filegroup now.
go
-- OK - so let's review what we have...
/* ********************************************************
 Database: TestFGDB
       Consists of 7 files
	TestFGDBData	      PRIMARY
	TestFGDBFile1	      Filegroup = fg, PROPERTY: DEFAULT
	TestFGDBFile2	      Filegroup = fg, PROPERTY: DEFAULT
	TestFGDBFile3	      Filegroup = fg, PROPERTY: DEFAULT
	TestFGDBTestFile1     Filegroup = fgtest, PROPERTY: READWRITE
	TestFGDBTestFile2     Filegroup = fgtest, PROPERTY: READWRITE
	TestFGDBLog	      Transaction Log file
Next - let's try the Shrinking stuff... First let's create the 
scenario where Filegroup fg is too big...right now we have quite 
a bit of space defined BUT not all of it used. We can Shrink and 
empty the TestFGDBFile3 file and then alter and remove it.
******************************************************** */
--Add some data to Demotable2 
while 1=1
insert dbo.DemoTable2 default values
go

DBCC SHRINKFILE(TestFGDBFile3, EmptyFile)
go
ALTER DATABASE TestFGDB
	REMOVE FILE TestFGDBFile3
go
sp_helpfile -- And then there were 6 :).
go
-- Now let's try and shrink the entire database so that 
-- there is only 50% free space for each file of the database
DBCC SHRINKDATABASE (TestFGDB, 75)
go
-- Then run 
sp_helpfile -- ...see the files are smaller...WAIT....NO - they're NOT!
-- DBCC SHRINKDATABASE does not allow you to shrink below
-- the initially created size. Here's a good section from the BOL.
/* **************************************
This is a straight copy from the "Remarks" section of
	DBCC SHRINKDATABASE

The target size for data and log files as calculated by 
DBCC SHRINKDATABASE can never be smaller than the 
minimum size of a file. The minimum size of a file is the 
size specified when the file was originally created, or the 
last explicit size set with a file size changing operation 
such as ALTER DATABASE with the MODIFY FILE option 
or DBCC SHRINKFILE. For example, if all the data and log 
files of mydb were specified to be 10 MB at the time 
CREATE DATABASE was executed, the minimum size of 
each file is 10 MB. DBCC SHRINKDATABASE cannot shrink 
any of the files smaller than 10 MB. If one of the files is 
explicitly grown to a size of 20 MB by using ALTER 
DATABASE with the MODIFY FILE option, the new minimum 
size of the file is 20 MB. To shrink a file to a size smaller 
than its minimum size, use DBCC SHRINKFILE and specify 
the new size. 
**************************************  */
go
-- So can we shrink to a size smaller than the initially created size!
-- Yes...but only file by file with DBCC SHRINKFILE...
-- For simplicity we'll shrink both of the fgtest files to 5 MB each
-- instead of their initially created size of 10MB (each).
DBCC SHRINKFILE(N'TestFGDBTestFile1', 5)
DBCC SHRINKFILE(N'TestFGDBTestFile2', 5)
go
sp_helpfile
go
-- Shrinking the Transaction log... may take a little bit more 
-- strategy! Check out these sections from the BOL 
-- in this order (so that everything makes sense):
	--Checkpoints and the Active Portion of the Log
	--Shrinking the Transaction Log